function invertbytes(str)
    local bin = string.reverse (str);
    return bin;
end

function hex2bytes(str)
    local bin = string.gsub (str, "%s*(%x%x)",function(x) return string.char(tonumber(x,16)) end);
    return bin;
end

function quoted2bytes(str)
    local bin = string.gsub (str, "%%(%x%x)",function(x) return string.char(tonumber(x,16)) end);
    return bin;
end

function uquoted2bytes(str)
    local bin = string.gsub (str, "%%u(%x%x%x%x)",function(x) return bytes2words(hex2bytes(x)) end);
    return bin;
end

function uquoted2UTF(str)
    local bin = string.gsub (str, "%%u(%x%x%x%x)",function(x) return unicode2UTF(tonumber(x,16)) end);
    return bin;
end

function uquoted2text(str)
    local bin = string.gsub (str, "%%u%x%x(%x%x)",function(x) return string.char(tonumber(x,16)) end);
    return bin;
end

function uquoted_be2text(str)
    local bin = string.gsub (str, "%%u(%x%x)%x%x",function(x) return string.char(tonumber(x,16)) end);
    return bin;
end

function bytes2words(str)
    local bin = string.gsub (str,"(.)(.)","%2%1");
    return bin;
end

function bytes2dwords(str)
    local bin = string.gsub (str,"(.)(.)(.)(.)","%4%3%2%1");
    return bin;
end

function unicode2text(str)
    local bin = string.gsub (str,"(.).","%1");
    return bin;
end

function unicode_be2text(str)
    local bin = string.gsub (str,".(.)","%1");
    return bin;
end

function unicode2UTF(bin)
    local res = "", b0, b1, b2, b3;
    b0 = bin;
    -- 0x00000000 - 0x0000007F 0xxxxxxx
    if (b0<0x80) then
       res = string.char(b0);
    else
       b1 = b0%0x40;
       b0 = (b0-b1)/0x40;
       -- 0x00000080 - 0x000007FF 110xxxxx 10xxxxxx
       if (b0<0x20) then
           res = string.char(0xC0+b0)..string.char(0x80+b1);
       else
           b2 = b0%0x40;
           b0 = (b0-b2)/0x40;
           -- 0x00000800 - 0x0000FFFF 1110xxxx 10xxxxxx 10xxxxxx
           if (b0<0x10) then
               res = string.char(0xE0+b0)..string.char(0x80+b2)..string.char(0x80+b1);
           else
               b3 = b0%0x40;
               b0 = (b0-b3)/0x40;
               -- 0x00010000 - 0x001FFFFF 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
               if (b0<0x8) then
                   res = string.char(0xF0+b0)..string.char(0x80+b3)..string.char(0x80+b2)..string.char(0x80+b1);
               end;
           end;
       end;
    end;
    return res;
end
